package msdn.example.AndroidToAzure;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;

import android.content.Context;
import android.graphics.*;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Gallery;
import android.widget.ImageView;

public class ImageAdapter extends BaseAdapter 
{    
	private Context mContext;    
	private ArrayList<BlobInfo> mBlobList=null;
	public ImageAdapter(Context c) 
	{      
		mContext = c; 
		mBlobList = ((AzureImageViewer) mContext).BlobList;
   
	}    
	public int getCount() 
	{        
		int count = mBlobList.size();
		return count;

	}    
	public Object getItem(int position) 
	{        
		return null;    
	}   
	public long getItemId(int position) 
	{        
		return 0;    
	}    

	
	public View getView(int position, View convertView, ViewGroup parent) 
	{        
		ImageView imageView;        
		if (convertView == null) 
		{  
			imageView = new ImageView(mContext);            
			imageView.setLayoutParams(new Gallery.LayoutParams(80, 70));            
			imageView.setScaleType(ImageView.ScaleType.FIT_XY);            
			imageView.setPadding(4, 4, 4, 4);        
		} 
		else 
		{            
			imageView = (ImageView) convertView;        
		}        
		BlobInfo CurrentBlob = mBlobList.get(position);
		
		Bitmap bm = getImageBitmap(CurrentBlob.Url);
		imageView.setImageBitmap(bm);
		CurrentBlob.ImageBitmap = bm;
		
		return imageView;    
	}   

    private Bitmap getImageBitmap(String url) { 
        Bitmap ImageBitmap = null; 
        try { 
            URL ImageURL = new URL(url); 
            URLConnection ImageConnection = ImageURL.openConnection(); 
            ImageConnection.connect(); 
            InputStream ImageStream = ImageConnection.getInputStream(); 
            BufferedInputStream BufferedStream = new BufferedInputStream(ImageStream); 
            ImageBitmap = BitmapFactory.decodeStream(BufferedStream); 
            BufferedStream.close(); 
            ImageStream.close(); 
       } catch (IOException e) { 
           Log.e("getImageBitmap", "Error getting bitmap"); 
       } 
       return ImageBitmap; 
    } 

	

	}
