﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Xml;
using System.Xml.Linq;
using System.Linq;
using System.Windows.Media.Imaging;
using System.Collections.Generic;


namespace WindowsPhoneApplication1
{
    public class StorageHelper
    {
        public static string AZURE_STORAGE_URL = "http://jofultz.blob.core.windows.net/filecabinet?comp=list";
        
        
        public static void GetBlobs()
        {
            WebClient StorageClient = new WebClient();
            StorageClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(StorageClient_DownloadBlobListCompleted);
            StorageClient.DownloadStringAsync(new Uri(AZURE_STORAGE_URL, UriKind.Absolute));

        }


        /// <summary>
        /// 
        /// </summary>
        /// Return XML in xDoc in the form:
        /// <EnumerationResults ContainerName="http://jofultz.blob.core.windows.net/filecabinet">
        /// - <Blobs>
        /// - <Blob>
        ///   <Name>2010-12-12+10.40.06.jpg</Name> 
        ///   <Url>http://jofultz.blob.core.windows.net/filecabinet/2010-12-12+10.40.06.jpg</Url> 
        ///   <LastModified>Sun, 02 Jan 2011 02:24:24 GMT</LastModified> 
        ///   <Etag>0x8CD783B4E56116C</Etag> 
        ///   <Size>263506</Size> 
        ///   <ContentType>image/jpeg</ContentType> 
        ///   <ContentEncoding /> 
        ///   <ContentLanguage /> 
        ///   </Blob>
        static void StorageClient_DownloadBlobListCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            XDocument xDoc = XDocument.Parse(e.Result);

            IEnumerable<StorageImage> ImageList = from Blob in xDoc.Descendants("Blob")
                            select new StorageImage()
                            {
                                Name = Blob.Descendants("Name").First().Value,
                                Url = Blob.Descendants("Url").First().Value,
                                Image = new BitmapImage(new Uri(Blob.Descendants("Url").First().Value, UriKind.Absolute))
                            };

            MainPage.ImageInfoList.Clear();
            foreach (StorageImage CurImg in ImageList)
            {
                MainPage.ImageInfoList.Add(CurImg);
            }
          

        }
    }
}
